' ---------------------------------------------------------------
' Copyright 2006, SAS Institute Inc.
' ---------------------------------------------------------------
Imports SAS.Shared.AddIns
Imports System.Text
Imports System.Xml
Imports System.IO


Public Class ClassicHat
    Implements SAS.Shared.AddIns.ISASTaskAddIn, SAS.Shared.AddIns.ISASTaskDescription, SAS.Shared.AddIns.ISASTask

    ' to hold the size parameter for this task
    Dim HatSize As Integer = 5

#Region "ISASTaskAddin"

    Public ReadOnly Property AddInDescription() As String Implements SAS.Shared.AddIns.ISASTaskAddIn.AddInDescription
        Get
            AddInDescription = "The classic hat example implemented in Visual Basic.NET"
        End Get
    End Property

    Public ReadOnly Property AddInName() As String Implements SAS.Shared.AddIns.ISASTaskAddIn.AddInName
        Get
            AddInName = "Classic Hat (VB)"
        End Get
    End Property

    Public Function Connect(ByVal Consumer As SAS.Shared.AddIns.ISASTaskConsumer) As Boolean Implements SAS.Shared.AddIns.ISASTaskAddIn.Connect
        ' nothing special needed for this task
        ' but if I needed to call back into the consumer (host application), I should
        ' save the Consumer passed in for future use.
        Connect = True
    End Function

    Public Sub Disconnect() Implements SAS.Shared.AddIns.ISASTaskAddIn.Disconnect
        ' nothing special needed for this task
    End Sub

    Public WriteOnly Property Language() As String Implements SAS.Shared.AddIns.ISASTaskAddIn.Language
        Set(ByVal Value As String)
            ' nothing special needed for this task
        End Set
    End Property

    Public Function Languages(ByRef Items() As String) As Integer Implements SAS.Shared.AddIns.ISASTaskAddIn.Languages
        ' supporting only english in this task
        Items = New String() {"en-US"}
        Languages = 1
    End Function

    Public ReadOnly Property VisibleInManager() As Boolean Implements SAS.Shared.AddIns.ISASTaskAddIn.VisibleInManager
        Get
            VisibleInManager = True
        End Get
    End Property

#End Region

#Region "ISASTaskDescription"

    Public ReadOnly Property Clsid() As String Implements SAS.Shared.AddIns.ISASTaskDescription.Clsid
        Get
            Clsid = "b99ccb91-8ec7-451c-a440-7af399c9d744"
        End Get
    End Property

    Public ReadOnly Property FriendlyName() As String Implements SAS.Shared.AddIns.ISASTaskDescription.FriendlyName
        Get
            FriendlyName = "Classic Hat (VB)"
        End Get
    End Property

    Public ReadOnly Property GeneratesListOutput() As Boolean Implements SAS.Shared.AddIns.ISASTaskDescription.GeneratesListOutput
        Get
            GeneratesListOutput = True
        End Get
    End Property

    Public ReadOnly Property GeneratesSasCode() As Boolean Implements SAS.Shared.AddIns.ISASTaskDescription.GeneratesSasCode
        Get
            GeneratesSasCode = True
        End Get
    End Property

    Public ReadOnly Property IconAssembly() As String Implements SAS.Shared.AddIns.ISASTaskDescription.IconAssembly
        Get
            ' return this assembly as the icon assembly
            IconAssembly = System.Reflection.Assembly.GetExecutingAssembly.Location
        End Get
    End Property

    Public ReadOnly Property IconName() As String Implements SAS.Shared.AddIns.ISASTaskDescription.IconName
        Get
            IconName = "SASVB.CustomTasks.SurfaceGraph.ico"
        End Get
    End Property

    Public ReadOnly Property MajorVersion() As Integer Implements SAS.Shared.AddIns.ISASTaskDescription.MajorVersion
        Get
            MajorVersion = 1
        End Get
    End Property

    Public ReadOnly Property MinorVersion() As Integer Implements SAS.Shared.AddIns.ISASTaskDescription.MinorVersion
        Get
            MinorVersion = 0
        End Get
    End Property

    Public ReadOnly Property NumericColsRequired() As Integer Implements SAS.Shared.AddIns.ISASTaskDescription.NumericColsRequired
        Get
            NumericColsRequired = 0
        End Get
    End Property

    Public ReadOnly Property ProcsUsed() As String Implements SAS.Shared.AddIns.ISASTaskDescription.ProcsUsed
        Get
            ProcsUsed = "DATA step; G3D"
        End Get
    End Property

    Public ReadOnly Property ProductsOptional() As String Implements SAS.Shared.AddIns.ISASTaskDescription.ProductsOptional
        Get
            ProductsOptional = ""
        End Get
    End Property

    Public ReadOnly Property ProductsRequired() As String Implements SAS.Shared.AddIns.ISASTaskDescription.ProductsRequired
        Get
            ProductsRequired = "BASE; GRAPH"
        End Get
    End Property

    Public ReadOnly Property RequiresData() As Boolean Implements SAS.Shared.AddIns.ISASTaskDescription.RequiresData
        Get
            RequiresData = False
        End Get
    End Property

    Public ReadOnly Property StandardCategory() As Boolean Implements SAS.Shared.AddIns.ISASTaskDescription.StandardCategory
        Get
            StandardCategory = False
        End Get
    End Property

    Public ReadOnly Property TaskCategory() As String Implements SAS.Shared.AddIns.ISASTaskDescription.TaskCategory
        Get
            TaskCategory = "Add-in Examples"
        End Get
    End Property

    Public ReadOnly Property TaskDescription() As String Implements SAS.Shared.AddIns.ISASTaskDescription.TaskDescription
        Get
            TaskDescription = "The classic hat example implemented in Visual Basic .NET"
        End Get
    End Property

    Public ReadOnly Property TaskName() As String Implements SAS.Shared.AddIns.ISASTaskDescription.TaskName
        Get
            TaskName = "Classic Hat (VB)"
        End Get
    End Property

    Public ReadOnly Property TaskType() As SAS.Shared.AddIns.ShowType Implements SAS.Shared.AddIns.ISASTaskDescription.TaskType
        Get
            TaskType = ShowType.Wizard
        End Get
    End Property

    Public ReadOnly Property Validation() As String Implements SAS.Shared.AddIns.ISASTaskDescription.Validation
        Get
            Validation = "SAS-supplied example"
        End Get
    End Property

    Public ReadOnly Property WhatIsDescription() As String Implements SAS.Shared.AddIns.ISASTaskDescription.WhatIsDescription
        Get
            WhatIsDescription = "The classic hat example implemented in Visual Basic .NET"
        End Get
    End Property

#End Region

#Region "ISASTask"

    Public Function Initialize() As Boolean Implements SAS.Shared.AddIns.ISASTask.Initialize
        Initialize = True
    End Function

    Public Property Label() As String Implements SAS.Shared.AddIns.ISASTask.Label
        Get
            Label = "Classic Hat (VB)"
        End Get
        Set(ByVal Value As String)

        End Set
    End Property

    Public ReadOnly Property OutputDataCount() As Integer Implements SAS.Shared.AddIns.ISASTask.OutputDataCount
        Get
            OutputDataCount = 0
        End Get
    End Property

    Public Function OutputDataInfo(ByVal Index As Integer, ByRef Source As String, ByRef Label As String) As SAS.Shared.AddIns.OutputData Implements SAS.Shared.AddIns.ISASTask.OutputDataInfo
        Source = Nothing
        Label = Nothing
        OutputDataInfo = OutputData.Unknown
    End Function

    Public ReadOnly Property RunLog() As String Implements SAS.Shared.AddIns.ISASTask.RunLog
        Get
            RunLog = Nothing
        End Get
    End Property

    Public ReadOnly Property SasCode() As String Implements SAS.Shared.AddIns.ISASTask.SasCode
        Get
            Dim sb As StringBuilder = New StringBuilder
            sb.Append("data hat;" & Environment.NewLine)
            sb.AppendFormat("do x = -{0} to {0} by .5;" & Environment.NewLine, HatSize)
            sb.AppendFormat("do y = -{0} to {0} by .5;" & Environment.NewLine, HatSize)
            sb.Append("z = sin(sqrt(y*y + x*x));" & Environment.NewLine)
            sb.Append("output;" & Environment.NewLine)
            sb.Append("end;" & Environment.NewLine)
            sb.Append("end;" & Environment.NewLine)
            sb.Append("proc g3d; plot y*x=z; run;" & Environment.NewLine)
            SasCode = sb.ToString
        End Get
    End Property

    Public Function Show(ByVal Owner As System.Windows.Forms.IWin32Window) As SAS.Shared.AddIns.ShowResult Implements SAS.Shared.AddIns.ISASTask.Show
        Dim dlg As ClassicHatForm = New ClassicHatForm
        dlg.HatSize = HatSize
        If dlg.ShowDialog() = Windows.Forms.DialogResult.OK Then
            HatSize = dlg.HatSize
            Show = ShowResult.RunNow
        Else
            Show = ShowResult.Canceled
        End If


    End Function

    Public Sub Terminate() Implements SAS.Shared.AddIns.ISASTask.Terminate
        ' nothing special needed for this task
    End Sub

    Public Property XmlState() As String Implements SAS.Shared.AddIns.ISASTask.XmlState
        Get
            Dim sw As StringWriter = New StringWriter
            Dim writer As XmlTextWriter = New XmlTextWriter(sw)
            writer.WriteStartElement("ClassicHat")
            writer.WriteElementString("Size", XmlConvert.ToString(HatSize))
            writer.WriteEndElement()
            writer.Close()

            XmlState = sw.ToString()

        End Get

        Set(ByVal Value As String)
            If Value <> Nothing And Value.Length > 0 Then
                Try
                    Dim sr As StringReader = New StringReader(Value)
                    Dim reader As XmlTextReader = New XmlTextReader(sr)
                    reader.ReadStartElement("ClassicHat")
                    HatSize = XmlConvert.ToInt32(reader.ReadElementString("Size"))
                    reader.ReadEndElement()
                    reader.Close()
                Catch
                End Try

            End If

        End Set
    End Property

#End Region

End Class
