' ---------------------------------------------------------------
' Copyright 2006, SAS Institute Inc.
' ---------------------------------------------------------------

' -----------------------------------------------------------------------------------
' Using SAS-supplied controls
' -----------------------------------------------------------------------------------
' This example uses the SASVariableSelector control.  To use this in your project:
' 1. Add a reference to SAS.EG.Controls.dll (located in C:\Program Files\SAS\Shared Files\BIClientTasks\3.0)
' 2. To use the control in the designer:
'     Right click on the toolbox and click Customize Toolbox...
'     Click Browse...  
'     Select C:\Program Files\SAS\Shared Files\BIClientTasks\3.0\SAS.EG.Controls.dll
'     Make sure that SASVariableSelector is checked
'
' There are many controls in the SAS.EG.Controls assembly.  Currently they are not all completely
' documented and supported for use by customers.  The SASVariableSelector is supported, although there
' currently is not any official end-user documentation for it.
' -----------------------------------------------------------------------------------

Imports System.Windows.Forms
Imports System.Drawing
Imports System.ComponentModel
Imports System.Resources

Imports SAS.Shared.AddIns

Public Class CompareForm
    Inherits System.Windows.Forms.Form

    Private _consumer As ISASTaskConsumer
    Private _taskModel As SASVB.Compare.Compare
    Private refRole As String = "Reference column"
    Private withRole As String = "Compare with"

    'Properties
    Public WriteOnly Property Consumer() As ISASTaskConsumer
        Set(ByVal value As ISASTaskConsumer)
            Me._consumer = value
        End Set
    End Property

    ' reference back to the task model
    Public WriteOnly Property TaskModel() As SASVB.Compare.Compare
        Set(ByVal Value As SASVB.Compare.Compare)
            Me._taskModel = Value
        End Set
    End Property

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents varSelector As SAS.EG.Controls.SASVariableSelector
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents btnOK As System.Windows.Forms.Button
    Friend WithEvents btnCancel As System.Windows.Forms.Button
    Friend WithEvents chkAllStats As System.Windows.Forms.CheckBox
    Friend WithEvents chkVerboseOutput As System.Windows.Forms.CheckBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(CompareForm))
        Me.varSelector = New SAS.EG.Controls.SASVariableSelector
        Me.Label1 = New System.Windows.Forms.Label
        Me.Label2 = New System.Windows.Forms.Label
        Me.Label3 = New System.Windows.Forms.Label
        Me.Label4 = New System.Windows.Forms.Label
        Me.btnOK = New System.Windows.Forms.Button
        Me.btnCancel = New System.Windows.Forms.Button
        Me.chkVerboseOutput = New System.Windows.Forms.CheckBox
        Me.chkAllStats = New System.Windows.Forms.CheckBox
        Me.SuspendLayout()
        '
        'varSelector
        '
        Me.varSelector.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.varSelector.CacheDirtyFlag = False
        Me.varSelector.CachePath = Nothing
        Me.varSelector.ColumnRolesTitle = ""
        Me.varSelector.ColumnsToAssignTitle = ""
        Me.varSelector.Location = New System.Drawing.Point(17, 57)
        Me.varSelector.Name = "varSelector"
        Me.varSelector.Size = New System.Drawing.Size(413, 168)
        Me.varSelector.SortVariablesBy = SAS.EG.Controls.VARSORT.DataOrder
        Me.varSelector.SortVariablesOrder = System.Windows.Forms.SortOrder.Ascending
        Me.varSelector.TabIndex = 0
        '
        'Label1
        '
        Me.Label1.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.ForeColor = System.Drawing.SystemColors.ActiveCaption
        Me.Label1.Location = New System.Drawing.Point(13, 15)
        Me.Label1.Name = "Label1"
        Me.Label1.TabIndex = 1
        Me.Label1.Text = "Step 1"
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(13, 37)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(420, 18)
        Me.Label2.TabIndex = 2
        Me.Label2.Text = "Select two columns to compare."
        '
        'Label3
        '
        Me.Label3.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.Label3.Location = New System.Drawing.Point(14, 263)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(420, 18)
        Me.Label3.TabIndex = 4
        Me.Label3.Text = "Specify comparison options."
        '
        'Label4
        '
        Me.Label4.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.Label4.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label4.ForeColor = System.Drawing.SystemColors.ActiveCaption
        Me.Label4.Location = New System.Drawing.Point(14, 241)
        Me.Label4.Name = "Label4"
        Me.Label4.TabIndex = 3
        Me.Label4.Text = "Step 2"
        '
        'btnOK
        '
        Me.btnOK.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.btnOK.Location = New System.Drawing.Point(271, 361)
        Me.btnOK.Name = "btnOK"
        Me.btnOK.TabIndex = 5
        Me.btnOK.Text = "OK"
        '
        'btnCancel
        '
        Me.btnCancel.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.btnCancel.Location = New System.Drawing.Point(359, 361)
        Me.btnCancel.Name = "btnCancel"
        Me.btnCancel.TabIndex = 6
        Me.btnCancel.Text = "Cancel"
        '
        'chkVerboseOutput
        '
        Me.chkVerboseOutput.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.chkVerboseOutput.Location = New System.Drawing.Point(32, 291)
        Me.chkVerboseOutput.Name = "chkVerboseOutput"
        Me.chkVerboseOutput.Size = New System.Drawing.Size(402, 24)
        Me.chkVerboseOutput.TabIndex = 7
        Me.chkVerboseOutput.Text = "Show detailed comparison summary"
        '
        'chkAllStats
        '
        Me.chkAllStats.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.chkAllStats.Location = New System.Drawing.Point(32, 322)
        Me.chkAllStats.Name = "chkAllStats"
        Me.chkAllStats.Size = New System.Drawing.Size(402, 24)
        Me.chkAllStats.TabIndex = 8
        Me.chkAllStats.Text = "Show table of summary statistics"
        '
        'CompareForm
        '
        Me.AcceptButton = Me.btnOK
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.CancelButton = Me.btnCancel
        Me.ClientSize = New System.Drawing.Size(444, 394)
        Me.Controls.Add(Me.chkAllStats)
        Me.Controls.Add(Me.chkVerboseOutput)
        Me.Controls.Add(Me.btnCancel)
        Me.Controls.Add(Me.btnOK)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Label4)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.varSelector)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.MinimumSize = New System.Drawing.Size(400, 400)
        Me.Name = "CompareForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
        Me.Text = "Compare Columns"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub CompareForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        varSelector.ColumnsToAssignTitle = "Available columns:"
        varSelector.ColumnRolesTitle = "Columns to compare:"

        ' Populate the available columns part of the variable selector
        Dim data As ISASTaskData
        data = _consumer.ActiveData
        Dim i As Int32
        Dim varParms As SAS.EG.Controls.SASVariableSelector.AddVariableParams
        Dim colInfo As ISASTaskDataColumn
        data.Accessor.Open()
        For i = 0 To data.Accessor.ColumnCount - 1
            colInfo = data.Accessor.ColumnInfoByIndex(i)
            varParms = GetVarParms(colInfo)
            varSelector.AddVariable(varParms)
        Next

        ' Populate the roles part of the variable selector
        Dim roleParms As New SAS.EG.Controls.SASVariableSelector.AddRoleParams
        roleParms.Name = refRole
        roleParms.Type = SAS.EG.Controls.SASVariableSelector.ROLETYPE.All
        roleParms.MinNumVars = 1
        roleParms.MaxNumVars = 1
        roleParms.Unique = True
        varSelector.AddRole(roleParms)

        roleParms = New SAS.EG.Controls.SASVariableSelector.AddRoleParams
        roleParms.Name = withRole
        roleParms.Type = SAS.EG.Controls.SASVariableSelector.ROLETYPE.All
        roleParms.MinNumVars = 1
        roleParms.MaxNumVars = 1
        roleParms.Unique = True
        varSelector.AddRole(roleParms)
        data.Accessor.Close()

        ' load task state
        chkAllStats.Checked = _taskModel.AllStats
        chkVerboseOutput.Checked = Not _taskModel.BriefSummary

        ' assign variables if possible
        If Not (_taskModel.ReferenceVar = "") Then
            Try
                colInfo = data.Accessor.ColumnInfoByName(_taskModel.ReferenceVar)
                If Not (colInfo Is Nothing) Then
                    varSelector.AssignVariable(refRole, _taskModel.ReferenceVar)
                End If
            Catch ex As Exception
            End Try
        End If

        If Not (_taskModel.WithVar = "") Then
            Try
                colInfo = data.Accessor.ColumnInfoByName(_taskModel.WithVar)
                If Not (colInfo Is Nothing) Then
                    varSelector.AssignVariable(withRole, _taskModel.WithVar)
                End If
            Catch ex As Exception
            End Try
        End If

        ' update controls
        UpdateControls()

    End Sub

    ' Given an ISASTaskDataColumn, populate an AddVariableParams object
    Private Function GetVarParms(ByVal colInfo As ISASTaskDataColumn) As SAS.EG.Controls.SASVariableSelector.AddVariableParams
        Dim varParms As New SAS.EG.Controls.SASVariableSelector.AddVariableParams
        varParms.Name = colInfo.Name
        varParms.Label = colInfo.Label
        varParms.Format = colInfo.Format
        varParms.Informat = colInfo.Format
        varParms.MaxLength = colInfo.Length

        ' simple approach: if it's not character, treat as numeric
        If colInfo.Group = VariableGroup.Character Then
            varParms.Type = SAS.EG.Controls.VARTYPE.Character
        Else : varParms.Type = SAS.EG.Controls.VARTYPE.Numeric
        End If

        Return varParms
    End Function

    Private Sub UpdateControls()

        ' GetNumberOfAssignedVariables can throw an exception if there are no variables assigned
        Try
            If varSelector.GetNumberOfAssignedVariables(refRole) = 1 And varSelector.GetNumberOfAssignedVariables(withRole) = 1 Then
                btnOK.Enabled = True
            Else : btnOK.Enabled = False
            End If
        Catch ex As Exception
            btnOK.Enabled = False
        End Try

    End Sub

    ' Compare the variable property type
    Private Function AreVarsSameType(ByVal var1 As String, ByVal var2 As String) As Boolean
        Dim colInfo1 As ISASTaskDataColumn
        Dim colInfo2 As ISASTaskDataColumn
        Dim isChar1, isChar2 As Boolean

        isChar1 = (_consumer.ActiveData.Accessor.ColumnInfoByName(var1).Group = VariableGroup.Character)
        isChar2 = (_consumer.ActiveData.Accessor.ColumnInfoByName(var2).Group = VariableGroup.Character)

        If (isChar1 = isChar2) Then
            Return True
        Else : Return False
        End If

    End Function

#Region "Event handlers"

    Private Sub varSelector_VariableAssigned(ByVal sender As Object, ByVal ea As SAS.EG.Controls.VariableAssignedEventArgs) Handles varSelector.VariableAssigned
        UpdateControls()

        If ea.RoleName = refRole Then
            _taskModel.ReferenceVar = ea.VarName
        ElseIf ea.RoleName = withRole Then
            _taskModel.WithVar = ea.VarName
        End If

        ' Ensure the two assigned variables are of compatible types
        If Not _taskModel.ReferenceVar = "" And Not _taskModel.WithVar = "" Then
            If Not (AreVarsSameType(_taskModel.ReferenceVar, _taskModel.WithVar)) Then
                MessageBox.Show("These two columns are of different types.  Please select different columns to compare.", "Mismatched column types")
            End If
        End If


    End Sub

    Private Sub varSelector_VariableDeassigned(ByVal sender As Object, ByVal ea As SAS.EG.Controls.VariableDeassignedEventArgs) Handles varSelector.VariableDeassigned
        UpdateControls()

        If ea.RoleName = refRole Then
            _taskModel.ReferenceVar = ""
        ElseIf ea.RoleName = withRole Then
            _taskModel.WithVar = ""
        End If

    End Sub

    Private Sub btnVerboseOutput_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkVerboseOutput.CheckedChanged
        _taskModel.BriefSummary = Not chkVerboseOutput.Checked
    End Sub

    Private Sub chkAllStats_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkAllStats.CheckedChanged
        _taskModel.AllStats = chkAllStats.Checked
    End Sub

#End Region

End Class
