' --------------------------------------------------------------------------------
'  Copyright (c) 2006 by SAS Institute Inc, Cary NC 27513 USA 
'  
'  MergeDataTaskForm.vb
' 
'  Type:	VB.NET Source Code
'  Product: Custom Task for use in SAS Enterprise Guide or 
'           the SAS Add-In for Microsoft Office
' -------------------------------------------------------------------------------

#Region " Namespaces "
Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports SAS.Shared.AddIns
#End Region

Namespace MergeData

    ' <summary>
    ' Summary description for MergeDataTaskForm.
    ' </summary>
    Public Class MergeDataTaskForm
        Inherits System.Windows.Forms.Form

#Region " Variables "

        'Required by the Windows Form Designer
        Private components As System.ComponentModel.IContainer

        'NOTE: The following procedure is required by the Windows Form Designer
        'It can be modified using the Windows Form Designer.  
        'Do not modify it using the code editor.
        Private WithEvents btnOK As System.Windows.Forms.Button
        Private WithEvents btnCancel As System.Windows.Forms.Button
        Friend WithEvents OutputLocationGroupBox As System.Windows.Forms.GroupBox
        Friend WithEvents OutputServerLabel As System.Windows.Forms.Label
        Friend WithEvents OutputLibraryLabel As System.Windows.Forms.Label
        Friend WithEvents OutputNameLabel As System.Windows.Forms.Label
        Friend WithEvents OutputServerComboBox As System.Windows.Forms.ComboBox
        Friend WithEvents OutputLibraryComboBox As System.Windows.Forms.ComboBox
        Friend WithEvents OutputMemberTextBox As System.Windows.Forms.TextBox
        Friend WithEvents DataToMergeGroupBox As System.Windows.Forms.GroupBox
        Friend WithEvents DataToMergeListBox As System.Windows.Forms.ListBox
        Friend WithEvents AddDataButton As System.Windows.Forms.Button
        Friend WithEvents CommonMergeVariableComboBox As System.Windows.Forms.ComboBox
        Friend WithEvents CommonMergeVariableLabel As System.Windows.Forms.Label
        Friend WithEvents RemoveDataButton As System.Windows.Forms.Button
        Friend WithEvents groupBox1 As System.Windows.Forms.GroupBox
        Friend WithEvents CommonVariableMergeRadioButton As System.Windows.Forms.RadioButton
        Friend WithEvents DatasetOrderMergeRadioButton As System.Windows.Forms.RadioButton
        Friend WithEvents MasterTransactionRadioButton As System.Windows.Forms.RadioButton
        Friend WithEvents CommonVariableMergeOutputMatchesRadioButton As System.Windows.Forms.RadioButton
        Private WithEvents btnHelp As System.Windows.Forms.Button
        Friend WithEvents MergeDataLabel As System.Windows.Forms.Label
        Private _LastServer As String = String.Empty
        Private _LastLibrary As String = String.Empty

#End Region


#Region " Constructor "
        Public Sub New()
            MyBase.New()

            'This call is required by the Windows Form Designer.
            InitializeComponent()

            UpdateRemoveDataButtonEnabledState()

            CommonMergeVariableComboBox.Text = "There are no common variables."
            CommonMergeVariableComboBox.Enabled = False

            AddDataButton.Select()

            SASCodeValidity()

        End Sub
#End Region


#Region " Dispose "
        'Form overrides dispose to clean up the component list.
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub
#End Region


#Region " Windows Form Designer generated code "

        '<System.Diagnostics.DebuggerStepThrough()> 
        Private Sub InitializeComponent()
            Me.btnOK = New System.Windows.Forms.Button
            Me.btnCancel = New System.Windows.Forms.Button
            Me.btnHelp = New System.Windows.Forms.Button
            Me.OutputLocationGroupBox = New System.Windows.Forms.GroupBox
            Me.OutputMemberTextBox = New System.Windows.Forms.TextBox
            Me.OutputLibraryComboBox = New System.Windows.Forms.ComboBox
            Me.OutputServerComboBox = New System.Windows.Forms.ComboBox
            Me.OutputNameLabel = New System.Windows.Forms.Label
            Me.OutputLibraryLabel = New System.Windows.Forms.Label
            Me.OutputServerLabel = New System.Windows.Forms.Label
            Me.DataToMergeGroupBox = New System.Windows.Forms.GroupBox
            Me.DataToMergeListBox = New System.Windows.Forms.ListBox
            Me.AddDataButton = New System.Windows.Forms.Button
            Me.CommonMergeVariableComboBox = New System.Windows.Forms.ComboBox
            Me.CommonMergeVariableLabel = New System.Windows.Forms.Label
            Me.RemoveDataButton = New System.Windows.Forms.Button
            Me.groupBox1 = New System.Windows.Forms.GroupBox
            Me.CommonVariableMergeRadioButton = New System.Windows.Forms.RadioButton
            Me.DatasetOrderMergeRadioButton = New System.Windows.Forms.RadioButton
            Me.MasterTransactionRadioButton = New System.Windows.Forms.RadioButton
            Me.CommonVariableMergeOutputMatchesRadioButton = New System.Windows.Forms.RadioButton
            Me.MergeDataLabel = New System.Windows.Forms.Label
            Me.OutputLocationGroupBox.SuspendLayout()
            Me.DataToMergeGroupBox.SuspendLayout()
            Me.groupBox1.SuspendLayout()
            Me.SuspendLayout()
            '
            'btnOK
            '
            Me.btnOK.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK
            Me.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnOK.Location = New System.Drawing.Point(248, 520)
            Me.btnOK.Name = "btnOK"
            Me.btnOK.TabIndex = 3
            Me.btnOK.Text = "OK"
            '
            'btnCancel
            '
            Me.btnCancel.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel
            Me.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnCancel.Location = New System.Drawing.Point(328, 520)
            Me.btnCancel.Name = "btnCancel"
            Me.btnCancel.TabIndex = 4
            Me.btnCancel.Text = "Cancel"
            '
            'btnHelp
            '
            Me.btnHelp.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.btnHelp.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnHelp.Location = New System.Drawing.Point(408, 520)
            Me.btnHelp.Name = "btnHelp"
            Me.btnHelp.TabIndex = 5
            Me.btnHelp.Text = "&Help"
            '
            'OutputLocationGroupBox
            '
            Me.OutputLocationGroupBox.Anchor = CType(((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.OutputLocationGroupBox.Controls.Add(Me.OutputMemberTextBox)
            Me.OutputLocationGroupBox.Controls.Add(Me.OutputLibraryComboBox)
            Me.OutputLocationGroupBox.Controls.Add(Me.OutputServerComboBox)
            Me.OutputLocationGroupBox.Controls.Add(Me.OutputNameLabel)
            Me.OutputLocationGroupBox.Controls.Add(Me.OutputLibraryLabel)
            Me.OutputLocationGroupBox.Controls.Add(Me.OutputServerLabel)
            Me.OutputLocationGroupBox.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.OutputLocationGroupBox.Location = New System.Drawing.Point(8, 392)
            Me.OutputLocationGroupBox.Name = "OutputLocationGroupBox"
            Me.OutputLocationGroupBox.Size = New System.Drawing.Size(476, 112)
            Me.OutputLocationGroupBox.TabIndex = 2
            Me.OutputLocationGroupBox.TabStop = False
            Me.OutputLocationGroupBox.Text = "Output Location"
            '
            'OutputMemberTextBox
            '
            Me.OutputMemberTextBox.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.OutputMemberTextBox.Location = New System.Drawing.Point(128, 76)
            Me.OutputMemberTextBox.Name = "OutputMemberTextBox"
            Me.OutputMemberTextBox.Size = New System.Drawing.Size(253, 20)
            Me.OutputMemberTextBox.TabIndex = 6
            Me.OutputMemberTextBox.Text = "DataMerge"
            '
            'OutputLibraryComboBox
            '
            Me.OutputLibraryComboBox.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.OutputLibraryComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
            Me.OutputLibraryComboBox.Location = New System.Drawing.Point(128, 48)
            Me.OutputLibraryComboBox.Name = "OutputLibraryComboBox"
            Me.OutputLibraryComboBox.Size = New System.Drawing.Size(253, 21)
            Me.OutputLibraryComboBox.TabIndex = 4
            '
            'OutputServerComboBox
            '
            Me.OutputServerComboBox.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.OutputServerComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
            Me.OutputServerComboBox.Location = New System.Drawing.Point(128, 20)
            Me.OutputServerComboBox.Name = "OutputServerComboBox"
            Me.OutputServerComboBox.Size = New System.Drawing.Size(253, 21)
            Me.OutputServerComboBox.TabIndex = 2
            '
            'OutputNameLabel
            '
            Me.OutputNameLabel.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.OutputNameLabel.Location = New System.Drawing.Point(16, 78)
            Me.OutputNameLabel.Name = "OutputNameLabel"
            Me.OutputNameLabel.Size = New System.Drawing.Size(104, 16)
            Me.OutputNameLabel.TabIndex = 0
            Me.OutputNameLabel.Text = "&Name:"
            '
            'OutputLibraryLabel
            '
            Me.OutputLibraryLabel.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.OutputLibraryLabel.Location = New System.Drawing.Point(16, 50)
            Me.OutputLibraryLabel.Name = "OutputLibraryLabel"
            Me.OutputLibraryLabel.Size = New System.Drawing.Size(104, 16)
            Me.OutputLibraryLabel.TabIndex = 0
            Me.OutputLibraryLabel.Text = "&Library:"
            '
            'OutputServerLabel
            '
            Me.OutputServerLabel.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.OutputServerLabel.Location = New System.Drawing.Point(16, 22)
            Me.OutputServerLabel.Name = "OutputServerLabel"
            Me.OutputServerLabel.Size = New System.Drawing.Size(104, 16)
            Me.OutputServerLabel.TabIndex = 0
            Me.OutputServerLabel.Text = "&Server:"
            '
            'DataToMergeGroupBox
            '
            Me.DataToMergeGroupBox.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                        Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.DataToMergeGroupBox.Controls.Add(Me.DataToMergeListBox)
            Me.DataToMergeGroupBox.Controls.Add(Me.AddDataButton)
            Me.DataToMergeGroupBox.Controls.Add(Me.CommonMergeVariableComboBox)
            Me.DataToMergeGroupBox.Controls.Add(Me.CommonMergeVariableLabel)
            Me.DataToMergeGroupBox.Controls.Add(Me.RemoveDataButton)
            Me.DataToMergeGroupBox.Location = New System.Drawing.Point(8, 152)
            Me.DataToMergeGroupBox.Name = "DataToMergeGroupBox"
            Me.DataToMergeGroupBox.Size = New System.Drawing.Size(476, 224)
            Me.DataToMergeGroupBox.TabIndex = 6
            Me.DataToMergeGroupBox.TabStop = False
            Me.DataToMergeGroupBox.Text = "Datasets to Merge"
            '
            'DataToMergeListBox
            '
            Me.DataToMergeListBox.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                        Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.DataToMergeListBox.Location = New System.Drawing.Point(16, 24)
            Me.DataToMergeListBox.Name = "DataToMergeListBox"
            Me.DataToMergeListBox.Size = New System.Drawing.Size(364, 121)
            Me.DataToMergeListBox.TabIndex = 2
            '
            'AddDataButton
            '
            Me.AddDataButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.AddDataButton.Location = New System.Drawing.Point(388, 24)
            Me.AddDataButton.Name = "AddDataButton"
            Me.AddDataButton.TabIndex = 0
            Me.AddDataButton.Text = "&Add..."
            '
            'CommonMergeVariableComboBox
            '
            Me.CommonMergeVariableComboBox.Anchor = CType(((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.CommonMergeVariableComboBox.Location = New System.Drawing.Point(16, 188)
            Me.CommonMergeVariableComboBox.Name = "CommonMergeVariableComboBox"
            Me.CommonMergeVariableComboBox.Size = New System.Drawing.Size(364, 21)
            Me.CommonMergeVariableComboBox.TabIndex = 4
            Me.CommonMergeVariableComboBox.Text = "There are no common variables."
            '
            'CommonMergeVariableLabel
            '
            Me.CommonMergeVariableLabel.Anchor = CType(((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.CommonMergeVariableLabel.Location = New System.Drawing.Point(16, 164)
            Me.CommonMergeVariableLabel.Name = "CommonMergeVariableLabel"
            Me.CommonMergeVariableLabel.Size = New System.Drawing.Size(364, 23)
            Me.CommonMergeVariableLabel.TabIndex = 3
            Me.CommonMergeVariableLabel.Text = "Common &variable to merge:"
            '
            'RemoveDataButton
            '
            Me.RemoveDataButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.RemoveDataButton.Location = New System.Drawing.Point(388, 56)
            Me.RemoveDataButton.Name = "RemoveDataButton"
            Me.RemoveDataButton.TabIndex = 1
            Me.RemoveDataButton.Text = "&Remove"
            '
            'groupBox1
            '
            Me.groupBox1.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.groupBox1.Controls.Add(Me.CommonVariableMergeRadioButton)
            Me.groupBox1.Controls.Add(Me.DatasetOrderMergeRadioButton)
            Me.groupBox1.Controls.Add(Me.MasterTransactionRadioButton)
            Me.groupBox1.Controls.Add(Me.CommonVariableMergeOutputMatchesRadioButton)
            Me.groupBox1.Location = New System.Drawing.Point(8, 8)
            Me.groupBox1.Name = "groupBox1"
            Me.groupBox1.Size = New System.Drawing.Size(476, 128)
            Me.groupBox1.TabIndex = 7
            Me.groupBox1.TabStop = False
            Me.groupBox1.Text = "Merge Type"
            '
            'CommonVariableMergeRadioButton
            '
            Me.CommonVariableMergeRadioButton.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.CommonVariableMergeRadioButton.Location = New System.Drawing.Point(8, 24)
            Me.CommonVariableMergeRadioButton.Name = "CommonVariableMergeRadioButton"
            Me.CommonVariableMergeRadioButton.Size = New System.Drawing.Size(460, 24)
            Me.CommonVariableMergeRadioButton.TabIndex = 0
            Me.CommonVariableMergeRadioButton.Text = "Merge based on &common variable"
            '
            'DatasetOrderMergeRadioButton
            '
            Me.DatasetOrderMergeRadioButton.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.DatasetOrderMergeRadioButton.Location = New System.Drawing.Point(8, 96)
            Me.DatasetOrderMergeRadioButton.Name = "DatasetOrderMergeRadioButton"
            Me.DatasetOrderMergeRadioButton.Size = New System.Drawing.Size(460, 24)
            Me.DatasetOrderMergeRadioButton.TabIndex = 1
            Me.DatasetOrderMergeRadioButton.Text = "Merge based on &dataset order"
            '
            'MasterTransactionRadioButton
            '
            Me.MasterTransactionRadioButton.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.MasterTransactionRadioButton.Location = New System.Drawing.Point(8, 72)
            Me.MasterTransactionRadioButton.Name = "MasterTransactionRadioButton"
            Me.MasterTransactionRadioButton.Size = New System.Drawing.Size(460, 24)
            Me.MasterTransactionRadioButton.TabIndex = 1
            Me.MasterTransactionRadioButton.Text = "Merge based on &master data set"
            '
            'CommonVariableMergeOutputMatchesRadioButton
            '
            Me.CommonVariableMergeOutputMatchesRadioButton.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.CommonVariableMergeOutputMatchesRadioButton.Location = New System.Drawing.Point(8, 48)
            Me.CommonVariableMergeOutputMatchesRadioButton.Name = "CommonVariableMergeOutputMatchesRadioButton"
            Me.CommonVariableMergeOutputMatchesRadioButton.Size = New System.Drawing.Size(460, 24)
            Me.CommonVariableMergeOutputMatchesRadioButton.TabIndex = 0
            Me.CommonVariableMergeOutputMatchesRadioButton.Text = "Merge based on c&ommon variable, only outputting matches"
            '
            'MergeDataLabel
            '
            Me.MergeDataLabel.Anchor = CType(((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.MergeDataLabel.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
            Me.MergeDataLabel.ForeColor = System.Drawing.SystemColors.InfoText
            Me.MergeDataLabel.Location = New System.Drawing.Point(1, 554)
            Me.MergeDataLabel.Name = "MergeDataLabel"
            Me.MergeDataLabel.Size = New System.Drawing.Size(476, 23)
            Me.MergeDataLabel.TabIndex = 6
            Me.MergeDataLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            '
            'MergeDataTaskForm
            '
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(492, 578)
            Me.Controls.Add(Me.MergeDataLabel)
            Me.Controls.Add(Me.groupBox1)
            Me.Controls.Add(Me.DataToMergeGroupBox)
            Me.Controls.Add(Me.OutputLocationGroupBox)
            Me.Controls.Add(Me.btnHelp)
            Me.Controls.Add(Me.btnCancel)
            Me.Controls.Add(Me.btnOK)
            Me.MaximizeBox = False
            Me.MinimizeBox = False
            Me.MinimumSize = New System.Drawing.Size(500, 552)
            Me.Name = "MergeDataTaskForm"
            Me.ShowInTaskbar = False
            Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
            Me.Text = "Merge Data SAS Custom Task"
            Me.OutputLocationGroupBox.ResumeLayout(False)
            Me.DataToMergeGroupBox.ResumeLayout(False)
            Me.groupBox1.ResumeLayout(False)
            Me.ResumeLayout(False)

        End Sub

        Dim _Consumer As ISASTaskConsumer
        Dim _taskModel As MergeDataTask
#End Region


#Region " AddDataButton_Click"

        Private Sub AddDataButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddDataButton.Click

            If Not _Consumer Is Nothing Then
                ' Let the user select the new data 
                ' and add it to the list of data to merge
                Dim tc2 As ISASTaskConsumer2 = CType(_Consumer, ISASTaskConsumer2)

                If Not tc2 Is Nothing Then
                    ' Setup the default Server and Library for the File Open Dialog
                    Dim serverAccessMode As serverAccessMode = serverAccessMode.OneServer

                    If ((Not tc2.InputData Is Nothing) And (tc2.InputData.Length > 0) And (DataToMergeListBox.Items.Count > 0)) Then
                        ' Get the default Server and Library location
                        Dim ds As ISASTaskData = tc2.InputData(tc2.InputData.Length - 1)
                        If Not ds Is Nothing Then
                            If _LastServer = String.Empty Then
                                _LastServer = ds.Server
                            End If
                            If ((Not ds.Server = _LastServer) Or (_LastLibrary = String.Empty)) Then
                                _LastLibrary = ds.Library
                            End If
                        End If
                    End If



                    ' Display the FOD and get the selected datasets  
                    Dim cookie As String = String.Empty
                    Dim inputDatasets As ISASTaskData() = tc2.ShowInputDataSelector(Me, DataSelectionMode.MultipleInput, serverAccessMode, _LastServer, _LastLibrary, "", cookie)

                    If inputDatasets Is Nothing Then
                        ' Simply return if the data selector was cancelled.
                        Return
                    ElseIf inputDatasets.Length <= 0 Then
                        Return
                    ElseIf inputDatasets(0) Is Nothing Then
                        Return
                    Else
                        ' Store the Server and Libray location that the user selected
                        _LastServer = inputDatasets(0).Server
                        _LastLibrary = inputDatasets(0).Library
                    End If


                    Try
                        Cursor = Cursors.WaitCursor

                        ' Add the selected datasets to the input data collection and add the dataset names to the Files to Merge listbox
                        For Each istd As ISASTaskData In inputDatasets
                            ' Add dataset to the input data collection
                            tc2.AddInputData(istd)

                            ' Add dataset name to the Files to Merge listbox
                            Dim index As Integer = DataToMergeListBox.Items.Add(istd.File)

                            ' Make the newly added dataset name be the selected item.
                            DataToMergeListBox.SelectedIndex = index

                            ' Update the CommonMergeVariableComboBox to display the variables
                            ' that are common to all the current datasets
                            UpdateCommonMergeVariableComboBox()

                            UpdateRemoveDataButtonEnabledState()

                            SASCodeValidity()
                        Next

                    Catch

                    Finally
                        Cursor = Cursors.Default
                    End Try

                End If
            End If
        End Sub


#End Region


#Region " RemoveDataButton_Click "

        Private Sub RemoveDataButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RemoveDataButton.Click

            Dim index As Integer = DataToMergeListBox.SelectedIndex

            ' Remove items from the DataToMergeListBox
            DataToMergeListBox.Items.RemoveAt(index)

            ' Remove item from the Input data collection
            Dim tc2 As ISASTaskConsumer2 = CType(_Consumer, ISASTaskConsumer2)

            If Not tc2 Is Nothing Then
                tc2.RemoveInputData(tc2.InputData(index))
            End If

            ' Set the selected item to the be the first item in the list
            Dim count As Integer = DataToMergeListBox.Items.Count
            If count > 0 Then
                DataToMergeListBox.SelectedIndex = 0
            End If
            If count < 2 Then
                CommonMergeVariableComboBox.Text = "There are no common variables."
                CommonMergeVariableComboBox.Enabled = False
            End If

            ' Update the CommonMergeVariableComboBox to display the variables
            ' that are common to all the current datasets
            UpdateCommonMergeVariableComboBox()

            UpdateRemoveDataButtonEnabledState()

            SASCodeValidity()
        End Sub

#End Region


#Region " UpdateRemoveDataButtonEnabledState "
        Private Function UpdateRemoveDataButtonEnabledState()
            If DataToMergeListBox.SelectedIndex = -1 Then
                RemoveDataButton.Enabled = False
            Else
                RemoveDataButton.Enabled = True
            End If
        End Function
#End Region


#Region "Properties for this add-in task"

        Public WriteOnly Property Consumer() As ISASTaskConsumer
            Set(ByVal Value As ISASTaskConsumer)
                _Consumer = Value
            End Set
        End Property

        Public Property taskModel() As MergeDataTask
            Get
                Return _taskModel
            End Get
            Set(ByVal Value As MergeDataTask)
                _taskModel = Value
            End Set
        End Property


#End Region


#Region "CommonMergeVariableComboBox_SelectedIndexChanged"

        Private Sub CommonMergeVariableComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommonMergeVariableComboBox.SelectedIndexChanged

            taskModel.sID = CommonMergeVariableComboBox.SelectedItem.ToString

            SASCodeValidity()

        End Sub

#End Region


#Region " UpdateCommonMergeVariableComboBox "

        Private Sub UpdateCommonMergeVariableComboBox()
            ' Reset the current items
            CommonMergeVariableComboBox.Items.Clear()

            If (DataToMergeListBox.Items.Count > 1) And CType(_Consumer, ISASTaskConsumer2).InputData.Length > 1 Then

                Dim CommonVars As New ArrayList
                Dim tc2 As ISASTaskConsumer2 = CType(_Consumer, ISASTaskConsumer2)

                If tc2 Is Nothing Then
                    Return
                End If

                Dim istd As ISASTaskData = Nothing
                For k As Integer = 0 To DataToMergeListBox.Items.Count - 1
                    ' Get the current task data
                    istd = tc2.InputData(k)

                    If istd Is Nothing Then
                        Return
                    End If

                    istd.Accessor.Open()
                    Dim colCount As Integer = istd.Accessor.ColumnCount

                    If k = 0 Then
                        ' Load the column names of the first dataset into the
                        ' CommonVars ArrayList
                        Dim dc As ISASTaskDataColumn = Nothing
                        For j As Integer = 0 To colCount - 1
                            dc = istd.Accessor.ColumnInfoByIndex(j)
                            CommonVars.Add(dc.Name)
                        Next
                    Else
                        ' Compare current dataset variable names to the common variable names
                        Dim tempCommonVars As New ArrayList

                        For j As Integer = 0 To colCount - 1
                            Dim dc As ISASTaskDataColumn = istd.Accessor.ColumnInfoByIndex(j)
                            If (Not dc Is Nothing) And (CommonVars.Contains(dc.Name)) Then
                                tempCommonVars.Add(dc.Name)
                            End If
                        Next

                        If tempCommonVars.Count = 0 Then
                            CommonVars.Clear()
                            Exit For
                        Else
                            CommonVars.Clear()
                            CommonVars.InsertRange(0, tempCommonVars.GetRange(0, tempCommonVars.Count))
                        End If
                    End If
                Next
                If CommonVars.Count = 0 Then
                    ' There are no common variables.
                    ' Disable the Common Merge Variable controls
                    CommonMergeVariableComboBox.Items.Clear()
                    CommonMergeVariableComboBox.Text = "There are no common variables."
                    CommonMergeVariableComboBox.Enabled = False
                Else
                    For i As Integer = 0 To CommonVars.Count - 1
                        CommonMergeVariableComboBox.Items.Add(CommonVars(i).ToString())
                    Next
                    CommonMergeVariableComboBox.SelectedIndex = CommonVars.Count - 1

                    CommonMergeVariableComboBox.Enabled = True
                    CommonMergeVariableLabel.Enabled = True
                End If

                SASCodeValidity()

            End If
        End Sub

#End Region


#Region " SASCodeValidity "
        Private Sub SASCodeValidity()

            Dim strStatus As String = String.Empty

            If DataToMergeListBox.Items.Count < 2 Then
                strStatus = "There must be at least 2 datasets to merge."
            ElseIf ((taskModel.MergeType = MergeDataTask.eMergeType.CommonVariable) Or _
                    (taskModel.MergeType = MergeDataTask.eMergeType.CommonVariableMergeOutputMatches) Or _
                    (taskModel.MergeType = MergeDataTask.eMergeType.MasterAndTransaction)) Then
                If CommonMergeVariableComboBox.SelectedItem Is Nothing Then
                    strStatus = "A common variable to merge must be selected."
                ElseIf CommonMergeVariableComboBox.SelectedItem.ToString() = String.Empty Then
                    strStatus = "A common variable to merge must be selected."
                End If
            End If

            If strStatus = String.Empty Then
                ' Everything is OK
                btnOK.Enabled = True
                btnOK.Focus()
                MergeDataLabel.Text = String.Empty
                CommonMergeVariableComboBox.Enabled = True
                CommonMergeVariableLabel.Enabled = True
            Else
                ' There is a problem, disable the OK button and update the status bar
                btnOK.Enabled = False
                MergeDataLabel.Text = strStatus
            End If

        End Sub


#End Region


#Region " MergeDataTaskForm_Load "

        Private Sub MergeDataTaskForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

            If taskModel Is Nothing Then
                Return
            End If

            ' Add items to the Data to Merge listbox
            PopulateMergeListBox()

            ' Assign common ID variable if possible
            AttemptCommonIDAssignment()

            If LoadServers(taskModel.sOutputServer) Then
                LoadLibraries()
            End If

            OutputMemberTextBox.Text = taskModel.sOutputMemberName

            SetMergeTypeRadioButton()

            SASCodeValidity()

        End Sub

#Region " Load Form Helper Methods "

#Region " Populate Merge Listbox "
        Private Sub PopulateMergeListBox()
            Dim tc2 As ISASTaskConsumer2 = _Consumer
            Dim i As Integer
            If Not tc2 Is Nothing Then
                Dim dsCount As Integer = tc2.InputData.Length
                For i = 0 To dsCount - 1
                    DataToMergeListBox.Items.Add(tc2.InputData(i).File.ToString())
                Next
            End If
        End Sub
#End Region

#Region " Assign common ID variable if possible "

        Private Sub AttemptCommonIDAssignment()
            If Not taskModel.sID = String.Empty Then
                Try
                    CommonMergeVariableComboBox.Items.Add(taskModel.sID)
                    CommonMergeVariableComboBox.SelectedIndex = 0
                Catch
                End Try
            End If
        End Sub

#End Region

#Region " SetMergeTypeRadioButton "
        Private Sub SetMergeTypeRadioButton()
            Select Case taskModel.MergeType
                Case MergeDataTask.eMergeType.CommonVariable
                    CommonVariableMergeRadioButton.Checked = True
                    CommonMergeVariableComboBox.Visible = True
                    CommonMergeVariableLabel.Visible = True
                Case MergeDataTask.eMergeType.CommonVariableMergeOutputMatches
                    CommonVariableMergeOutputMatchesRadioButton.Checked = True
                    CommonMergeVariableComboBox.Visible = True
                    CommonMergeVariableLabel.Visible = True
                Case MergeDataTask.eMergeType.MasterAndTransaction
                    MasterTransactionRadioButton.Checked = True
                    CommonMergeVariableComboBox.Visible = True
                    CommonMergeVariableLabel.Visible = True
                Case Else
                    DatasetOrderMergeRadioButton.Checked = True
                    CommonMergeVariableComboBox.Visible = False
                    CommonMergeVariableLabel.Visible = False
            End Select
        End Sub
#End Region

#End Region


#End Region


#Region " Merge Order Checked Changed "

        Private Sub MergeOrderCheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CommonVariableMergeRadioButton.CheckedChanged, CommonVariableMergeOutputMatchesRadioButton.CheckedChanged, DatasetOrderMergeRadioButton.CheckedChanged, MasterTransactionRadioButton.CheckedChanged

            If CommonVariableMergeRadioButton.Checked Then
                taskModel.MergeType = MergeDataTask.eMergeType.CommonVariable
                CommonMergeVariableComboBox.Visible = True
                CommonMergeVariableLabel.Visible = True

            ElseIf CommonVariableMergeOutputMatchesRadioButton.Checked Then
                taskModel.MergeType = MergeDataTask.eMergeType.CommonVariableMergeOutputMatches
                CommonMergeVariableComboBox.Visible = True
                CommonMergeVariableLabel.Visible = True

            ElseIf MasterTransactionRadioButton.Checked Then
                taskModel.MergeType = MergeDataTask.eMergeType.MasterAndTransaction
                CommonMergeVariableComboBox.Visible = True
                CommonMergeVariableLabel.Visible = True

            Else
                taskModel.MergeType = MergeDataTask.eMergeType.Datasetorder
                CommonMergeVariableComboBox.Visible = True
                CommonMergeVariableLabel.Visible = True

            End If
        End Sub


#End Region


#Region " Load Servers "
        Private Function LoadServers(ByVal newServer As String) As Boolean
            Dim serverList As String()

            If ((_Consumer Is Nothing) Or (_Consumer.Servers(serverList) <= 0)) Then
                OutputServerComboBox.Items.Clear()
                Return False
            End If

            OutputServerComboBox.Items.Clear()

            Dim currentServerItem As Integer = -1
            Dim localServerItem As Integer = -1

            For Each serverName As String In serverList
                OutputServerComboBox.Items.Add(serverName.Trim())

                If serverName.Trim() = newServer.Trim() Then
                    currentServerItem = OutputServerComboBox.Items.Count - 1
                End If

                If serverName.Trim.ToUpper = "LOCAL" Then
                    localServerItem = OutputServerComboBox.Items.Count - 1
                End If
            Next

            If currentServerItem = -1 Then
                If localServerItem = -1 Then
                    OutputServerComboBox.SelectedIndex = -1
                    Return False
                End If

                taskModel.sOutputServer = OutputServerComboBox.Items(localServerItem).ToString()
                OutputServerComboBox.SelectedIndex = localServerItem
            Else
                taskModel.sOutputServer = newServer.Trim()
                OutputServerComboBox.SelectedIndex = currentServerItem
            End If

            Return True
        End Function

#End Region


#Region " Load Libraries "

        Private Function LoadLibraries() As Boolean
            If _Consumer Is Nothing Then
                Throw New System.Exception("No libraries are available.")
            End If
            Dim consumer2 As ISASTaskConsumer2 = _Consumer
            If consumer2 Is Nothing Then
                Throw New System.Exception("Unable to obtain an ISASTaskConsumer2 interface from the supplied consumer.")
            End If

            Dim libraryList As String()

            Dim intLibraries As Integer
            Try
                intLibraries = consumer2.Libraries(taskModel.sOutputServer, LibraryType.ReadWrite, libraryList)

                OutputLibraryComboBox.Items.Clear()

                Dim currentLibraryItem As Integer = -1
                Dim workLibraryItem As Integer = -1

                For Each libraryName As String In libraryList
                    OutputLibraryComboBox.Items.Add(libraryName.Trim())

                    If libraryName.Trim.ToUpper = taskModel.sOutputLibrary Then
                        currentLibraryItem = OutputLibraryComboBox.Items.Count - 1
                    End If

                    If libraryName.Trim.ToUpper = "WORK" Then
                        workLibraryItem = OutputLibraryComboBox.Items.Count - 1
                    End If
                Next

                If Not currentLibraryItem = 1 Then
                    OutputLibraryComboBox.SelectedIndex = currentLibraryItem
                Else
                    OutputLibraryComboBox.SelectedIndex = workLibraryItem
                End If

                If (currentLibraryItem = -1 And workLibraryItem = -1) Then
                    Return False
                End If

            Catch ex As Exception
                OutputLibraryComboBox.Items.Clear()
                MergeDataLabel.Text = "Unable to access server and its libraries."
            End Try

            Return True
        End Function

#End Region


#Region " HelpButton_Click"
        Private Sub HelpButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHelp.Click

            ' Display Help Information
            Dim hf As New MergeDataHelpForm2
            hf.ShowDialog()

        End Sub
#End Region


#Region " OutputServerComboBox_SelectedIndexChanged "

        Private Sub OutputServerComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OutputServerComboBox.SelectedIndexChanged
            ' Load the writeable libraries on the newly selected server
            taskModel.sOutputServer = OutputServerComboBox.SelectedItem.ToString().Trim
            LoadLibraries()
        End Sub

#End Region


#Region " OutputLibraryComboBox_SelectedIndexChanged "

        Private Sub OutputLibraryComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OutputLibraryComboBox.SelectedIndexChanged
            ' Get the newly selected library name
            Dim OutputLibrary As String = OutputLibraryComboBox.SelectedItem.ToString.Trim

            If OutputLibrary = String.Empty Then
                ' We have a blank library name, use the WORK library
                taskModel.sOutputLibrary = "WORK"
            Else
                ' Use the newly selected library
                taskModel.sOutputLibrary = OutputLibrary
            End If
        End Sub

#End Region


#Region " OutputMemberTextBox_TextChanged "

        Private Sub OutputMemberTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OutputMemberTextBox.TextChanged
            ' Event is firing on initialization with default text, check to be sure the
            ' taskModel object exists first before setting values.
            If Not taskModel Is Nothing Then
                taskModel.sOutputMemberName = OutputMemberTextBox.Text.ToString.Trim
            End If
        End Sub

#End Region


#Region " DataToMergeListBox_SelectedValueChanged "

        Private Sub DataToMergeListBox_SelectedValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles DataToMergeListBox.SelectedValueChanged
            If DataToMergeListBox.SelectedItems.Count > 0 Then
                RemoveDataButton.Enabled = True
            Else
                RemoveDataButton.Enabled = False
            End If
        End Sub

#End Region


#Region " MergeDataTaskForm_KeyUp "

        Private Sub MergeDataTaskForm_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp
            If e.KeyCode = Keys.F1 Then
                HelpButton_Click(sender, e)
            End If
        End Sub


#End Region

    End Class
End Namespace
