' =========================================================
'   
'                Create Picture Format Task
'
'                          a SAS Custom Task Example 
'
' Copyright (C) 2006 by SAS Institute Inc., Cary, NC 27513
'
' ---------------------------------------------------------
' This form is displayed as a small help window from the
' range definition panel. The information it contains
' relates to the definition of PICTURE format mask strings. 
' The help text comes from the associated RESX file in the
' form of an RTF string. 
' =========================================================

Imports System.Reflection
Imports System.Resources
Imports System.Drawing

Namespace SASVB.CustomTasks
    Public Class RangesHelpForm
        Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

        Public Sub New()
            MyBase.New()

            'This call is required by the Windows Form Designer.
            InitializeComponent()

            ' Load the icon for the form's control menu on the title bar.
            Me.Icon = New Icon(System.Reflection.Assembly.GetExecutingAssembly().GetManifestResourceStream("SASVB.CustomTasks.RangesHelp.ico"))
        End Sub

        'Form overrides dispose to clean up the component list.
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub

        'Required by the Windows Form Designer
        Private components As System.ComponentModel.IContainer

        'NOTE: The following procedure is required by the Windows Form Designer
        'It can be modified using the Windows Form Designer.  
        'Do not modify it using the code editor.
        Friend WithEvents RichTextBox1 As System.Windows.Forms.RichTextBox
        Friend WithEvents btnClose As System.Windows.Forms.Button
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Me.btnClose = New System.Windows.Forms.Button
            Me.RichTextBox1 = New System.Windows.Forms.RichTextBox
            Me.SuspendLayout()
            '
            'btnClose
            '
            Me.btnClose.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.btnClose.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnClose.Location = New System.Drawing.Point(304, 376)
            Me.btnClose.Name = "btnClose"
            Me.btnClose.Size = New System.Drawing.Size(64, 24)
            Me.btnClose.TabIndex = 1
            Me.btnClose.Text = "Close"
            '
            'RichTextBox1
            '
            Me.RichTextBox1.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                        Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.RichTextBox1.Location = New System.Drawing.Point(0, 0)
            Me.RichTextBox1.Name = "RichTextBox1"
            Me.RichTextBox1.ReadOnly = True
            Me.RichTextBox1.Size = New System.Drawing.Size(376, 368)
            Me.RichTextBox1.TabIndex = 3
            Me.RichTextBox1.Text = ""
            '
            'RangesHelpForm
            '
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(376, 406)
            Me.Controls.Add(Me.RichTextBox1)
            Me.Controls.Add(Me.btnClose)
            Me.Name = "RangesHelpForm"
            Me.ShowInTaskbar = False
            Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
            Me.Text = "Help with Picture Format Masks"
            Me.ResumeLayout(False)

        End Sub

#End Region

        Private Sub RangesHelpForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            ' Load the RTF string from the translatable resources file
            ' and assign it to the RTF control as its RTF value.
            Dim rm As ResourceManager = New ResourceManager("SASVB.CustomTasks.RangeHelpFormTranslatable", Me.GetType.Assembly())
            RichTextBox1.Rtf = rm.GetString("HelpText")
        End Sub

        Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
            ' The Close button has been pressed, so we want to dismiss
            ' the dialog.
            Me.DialogResult = Windows.Forms.DialogResult.OK
        End Sub
    End Class
End Namespace
