' ---------------------------------------------------------------
' Copyright 2006, SAS Institute Inc.
' ---------------------------------------------------------------
Imports System.Windows.Forms
Imports System.Drawing
Imports System.ComponentModel

Namespace SASVB.SASProducts
    ' Purpose: Special list view to show message when list is empty

    Public Class SASListView
        Inherits System.Windows.Forms.ListView

        ' Fields
        Private _b As Boolean
        Private _msg As String

        ' Properties
        Public WriteOnly Property Message() As String
            Set(ByVal value As String)
                Me._msg = value
                MyBase.Invalidate()
            End Set
        End Property

        ' Constructor
        Public Sub New()
            Me.components = Nothing
            Me._b = True
            Me._msg = "Select a server and click Show SAS Products"
            Me.InitializeComponent()
            AddHandler MyBase.Resize, New EventHandler(AddressOf Me.SASListView_Resize)
        End Sub

#Region "Handle special message for empty list"

        Private Sub SASListView_Resize(ByVal sender As Object, ByVal e As EventArgs)
            If Me._b Then
                MyBase.Invalidate()
            End If
        End Sub

        Protected Overrides Sub WndProc(ByRef m As Message)
            MyBase.WndProc(m)
            If (m.Msg = 20) Then
                If (MyBase.Items.Count = 0) Then
                    MyBase.GridLines = False
                    Me._b = True
                    Dim graphics1 As Graphics = MyBase.CreateGraphics
                    Dim num1 As Integer = 0
                    Dim ef1 As SizeF = graphics1.MeasureString(Me._msg, Me.Font)
                    Dim size1 As Size = ef1.ToSize
                    num1 = (MyBase.Width - size1.Width)
                    num1 = (num1 / 2)
                    graphics1.DrawString(Me._msg, Me.Font, SystemBrushes.ControlText, CType(num1, Single), CType(30.0!, Single))
                Else
                    If Me._b Then
                        MyBase.GridLines = True
                        MyBase.Invalidate()
                        Me._b = False
                    End If
                End If
            End If
            If (m.Msg = 4127) Then
                MyBase.Invalidate()
            End If
        End Sub

#End Region

#Region " Windows Form Designer generated code "

        'UserControl overrides dispose to clean up the component list.
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub

        'Required by the Windows Form Designer
        Private components As System.ComponentModel.IContainer

        'NOTE: The following procedure is required by the Windows Form Designer
        'It can be modified using the Windows Form Designer.  
        'Do not modify it using the code editor.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            components = New System.ComponentModel.Container
        End Sub

#End Region

    End Class

End Namespace