' ---------------------------------------------------------------
' Copyright 2006, SAS Institute Inc.
' ---------------------------------------------------------------
Imports System.Windows.Forms
Imports System.Drawing
Imports System.ComponentModel
Imports System.Resources
Imports System.Data
Imports System.Data.OleDb

Imports SAS
Imports SAS.Shared.AddIns

Namespace SASVB.SASProducts

    Public Class SASProductsForm
        Inherits System.Windows.Forms.Form

#Region "Properties"

        ' Enum for images
        Private Enum ProdIcons
            ' Fields
            Licensed = 0
            NotLicensed = 1
        End Enum

        ' Private members
        Private _createReport As Boolean
        Private _currServer As String
        Private _sasProgram As String
        Private _consumer As ISASTaskConsumer
        Private imgList As ImageList = New ImageList


        'Properties
        Public WriteOnly Property Consumer() As ISASTaskConsumer
            Set(ByVal value As ISASTaskConsumer)
                Me._consumer = value
            End Set
        End Property

        Public ReadOnly Property CreateReport() As Boolean
            Get
                Return Me._createReport
            End Get
        End Property

        Public ReadOnly Property CurrentServer() As String
            Get
                Return Me._currServer
            End Get
        End Property

#End Region

#Region " Windows Form Designer generated code "

        Public Sub New()
            MyBase.New()

            'This call is required by the Windows Form Designer.
            InitializeComponent()

            Me._sasProgram = Global.ReadFileFromAssembly("SASVB.CustomTasks.sasproducts.sas")
            Me.imgList.Images.Add(Global.GetImageFromResources("licensed.ico", New Size(16, 16)))
            Me.imgList.Images.Add(Global.GetImageFromResources("notlicensed.ico", New Size(16, 16)))
            Me.lvProducts.SmallImageList = Me.imgList
            Me.lvProducts.LargeImageList = Me.imgList

        End Sub

        'Form overrides dispose to clean up the component list.
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub

        'Required by the Windows Form Designer
        Private components As System.ComponentModel.IContainer

        'NOTE: The following procedure is required by the Windows Form Designer
        'It can be modified using the Windows Form Designer.  
        'Do not modify it using the code editor.
        Friend WithEvents lblDesc As System.Windows.Forms.Label
        Friend WithEvents label1 As System.Windows.Forms.Label
        Friend WithEvents btnCheck As System.Windows.Forms.Button
        Friend WithEvents lvProducts As SASVB.SASProducts.SASListView
        Friend WithEvents sbar As System.Windows.Forms.StatusBar
        Friend WithEvents btnClose As System.Windows.Forms.Button
        Friend WithEvents btnReport As System.Windows.Forms.Button
        Friend WithEvents cmbServers As System.Windows.Forms.ComboBox
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(SASProductsForm))
            Me.lblDesc = New System.Windows.Forms.Label
            Me.label1 = New System.Windows.Forms.Label
            Me.cmbServers = New System.Windows.Forms.ComboBox
            Me.btnCheck = New System.Windows.Forms.Button
            Me.lvProducts = New SASVB.SASProducts.SASListView
            Me.sbar = New System.Windows.Forms.StatusBar
            Me.btnClose = New System.Windows.Forms.Button
            Me.btnReport = New System.Windows.Forms.Button
            Me.SuspendLayout()
            '
            'lblDesc
            '
            Me.lblDesc.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.lblDesc.Location = New System.Drawing.Point(16, 14)
            Me.lblDesc.Name = "lblDesc"
            Me.lblDesc.Size = New System.Drawing.Size(366, 34)
            Me.lblDesc.TabIndex = 9
            Me.lblDesc.Text = "Use this task to determine which SAS products are licensed and installed on your " & _
            "SAS server."
            '
            'label1
            '
            Me.label1.Location = New System.Drawing.Point(14, 52)
            Me.label1.Name = "label1"
            Me.label1.Size = New System.Drawing.Size(249, 18)
            Me.label1.TabIndex = 8
            Me.label1.Text = "Select the SAS server to examine:"
            '
            'cmbServers
            '
            Me.cmbServers.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
            Me.cmbServers.Location = New System.Drawing.Point(13, 76)
            Me.cmbServers.Name = "cmbServers"
            Me.cmbServers.Size = New System.Drawing.Size(236, 21)
            Me.cmbServers.TabIndex = 10
            '
            'btnCheck
            '
            Me.btnCheck.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.btnCheck.Location = New System.Drawing.Point(257, 76)
            Me.btnCheck.Name = "btnCheck"
            Me.btnCheck.Size = New System.Drawing.Size(125, 23)
            Me.btnCheck.TabIndex = 11
            Me.btnCheck.Text = "Show SAS Products"
            '
            'lvProducts
            '
            Me.lvProducts.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                        Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.lvProducts.Location = New System.Drawing.Point(10, 106)
            Me.lvProducts.Name = "lvProducts"
            Me.lvProducts.Size = New System.Drawing.Size(371, 172)
            Me.lvProducts.TabIndex = 12
            Me.lvProducts.View = System.Windows.Forms.View.Details
            '
            'sbar
            '
            Me.sbar.Location = New System.Drawing.Point(0, 317)
            Me.sbar.Name = "sbar"
            Me.sbar.Size = New System.Drawing.Size(395, 22)
            Me.sbar.TabIndex = 13
            '
            'btnClose
            '
            Me.btnClose.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.btnClose.Location = New System.Drawing.Point(310, 287)
            Me.btnClose.Name = "btnClose"
            Me.btnClose.TabIndex = 14
            Me.btnClose.Text = "Close"
            '
            'btnReport
            '
            Me.btnReport.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.btnReport.Location = New System.Drawing.Point(196, 287)
            Me.btnReport.Name = "btnReport"
            Me.btnReport.Size = New System.Drawing.Size(103, 23)
            Me.btnReport.TabIndex = 15
            Me.btnReport.Text = "Create Report"
            '
            'SASProductsForm
            '
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(395, 339)
            Me.Controls.Add(Me.btnReport)
            Me.Controls.Add(Me.btnClose)
            Me.Controls.Add(Me.sbar)
            Me.Controls.Add(Me.lvProducts)
            Me.Controls.Add(Me.btnCheck)
            Me.Controls.Add(Me.cmbServers)
            Me.Controls.Add(Me.lblDesc)
            Me.Controls.Add(Me.label1)
            Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
            Me.MaximizeBox = False
            Me.MinimizeBox = False
            Me.MinimumSize = New System.Drawing.Size(369, 373)
            Me.Name = "SASProductsForm"
            Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
            Me.Text = "SAS Product Checker"
            Me.ResumeLayout(False)

        End Sub

#End Region

#Region "Event handlers"

        Private Sub SASProductsForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

            ' get the list of servers from the application
            Dim textArray1 As String()
            If (Me._consumer Is Nothing) Then
                Throw New Exception("Must set ISASTaskConsumer as Consumer property!")
            End If
            Me._consumer.Servers(textArray1)
            If (textArray1.Length = 0) Then
                textArray1 = New String() {Me._consumer.AssignedServer}
            End If
            Me.cmbServers.Items.AddRange(textArray1)
            If (Me._consumer.AssignedServer.Length > 0) Then
                Me.cmbServers.SelectedItem = Me._consumer.AssignedServer
            End If
            Me._currServer = Me.cmbServers.SelectedItem.ToString

            ' set up the list view columns
            Dim header1 As New ColumnHeader
            header1.Text = "Product Name"
            header1.Width = (Me.lvProducts.Width / 2)
            Me.lvProducts.Columns.Add(header1)
            header1 = New ColumnHeader
            header1.Text = "Licensed?"
            header1.Width = (Me.lvProducts.Width / 4)
            Me.lvProducts.Columns.Add(header1)
            header1 = New ColumnHeader
            header1.Text = "Installed?"
            header1.Width = (Me.lvProducts.Width / 4)
            Me.lvProducts.Columns.Add(header1)
        End Sub

        Private Sub btnReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReport.Click
            Me._createReport = True
            MyBase.Close()
        End Sub

        Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
            MyBase.Close()
        End Sub

        Private Sub cmbServers_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbServers.SelectedIndexChanged
            Me._currServer = Me.cmbServers.SelectedItem.ToString
        End Sub

        ' Submit the SAS program to discover the products
        Private Sub btnCheck_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheck.Click
            Me.sbar.Text = String.Format("Analyzing products on {0}...", Me._currServer)
            Me.UpdateControls(False)

            ' get the ISASTaskSubmit interface from the application
            Dim submit1 As ISASTaskSubmit = Me._consumer.Submit
            If (Not submit1 Is Nothing) Then
                Dim cursor1 As Cursor = Cursor.Current
                Cursor.Current = Cursors.WaitCursor
                Me.lvProducts.Items.Clear()
                Me.lvProducts.Message = String.Format("Analyzing products on {0}...", Me._currServer)

                ' this call submits the code synchronously to the server
                submit1.SubmitCode(Me._sasProgram, Me._currServer, False)
                Cursor.Current = cursor1
                Me.PopulateProductList()
            Else
                MessageBox.Show("This application does not support submitting code from a task.", "Not supported")
            End If
        End Sub

        Private Sub UpdateControls(ByVal bEnable As Boolean)
            Me.btnCheck.Enabled = bEnable
            Me.cmbServers.Enabled = bEnable
        End Sub

#End Region

#Region "Read the product data and populate list view"

        Private Sub PopulateProductList()
            Dim cursor1 As Cursor = Cursor.Current
            Cursor.Current = Cursors.WaitCursor

            ' get the SAS workspace
            Dim workspace1 As Workspace = Nothing
            Try
                workspace1 = Me._consumer.Workspace(Me._currServer)
            Catch exception1 As Exception
                Throw New Exception("ISASTaskConsumer.Workspace is not usable!", exception1)
            End Try

            ' Use ADO to read the products dataset generated by the submitted code
            If ((Me._currServer.Length > 0) AndAlso (Not workspace1 Is Nothing)) Then
                Dim recordset1 As New ADODB.RecordsetClass
                Dim connection1 As New ADODB.ConnectionClass
                Try
                    connection1.Open(("Provider=sas.iomprovider.1; SAS Workspace ID=" & workspace1.UniqueIdentifier), "", "", 0)
                    Dim text1 As String = "select prodname, licensed, installed from work.sasprods"
                    recordset1.Open(text1, connection1, ADODB.CursorTypeEnum.adOpenForwardOnly, ADODB.LockTypeEnum.adLockReadOnly, 1)

                    ' populate the list view with the data
                    Do While Not recordset1.EOF
                        Dim item1 As New ListViewItem(recordset1.Fields.Item("prodname").Value.ToString)
                        Dim text2 As String
                        If (recordset1.Fields.Item("licensed").Value.ToString.Trim = "1") Then
                            text2 = "Yes"
                        Else : text2 = "No"
                        End If
                        Dim text3 As String = recordset1.Fields.Item("installed").Value.ToString.Trim
                        If (Not text3 Is "<unknown>") Then
                            text3 = IIf((text3.Length > 0), "Yes", "No")
                        End If
                        item1.SubItems.Add(text2)
                        item1.SubItems.Add(text3)
                        If ((text2 Is "Yes") AndAlso (text3 Is "No")) Then
                            item1.ForeColor = Color.OliveDrab
                        Else
                            If ((text2 Is "No") AndAlso (text3 Is "No")) Then
                                item1.ForeColor = SystemColors.GrayText
                            End If
                        End If
                        item1.ImageIndex = IIf((text2 Is "Yes"), 0, 1)
                        Me.lvProducts.Items.Add(item1)
                        recordset1.MoveNext()
                    Loop
                Catch obj1 As System.Exception
                Finally
                    connection1.Close()
                End Try
            End If

            Cursor.Current = cursor1
            Me.UpdateControls(True)
            Me.sbar.Text = String.Format("Analysis of {0} complete!", Me._currServer)
        End Sub

#End Region

    End Class

End Namespace

